import urllib2, urllib
import sys, os
import logging

class HttpRequestor(object):
	"""
	Helper class for sending requests of HTTP with GET and POST
	"""

	apiUrl = None 				#: domain url to use when sending requests
	apiMethod = None 			#: api method to use when sending requests
	apiParams = None 			#: parameters to send to the method when sending requests
	apiHeader = None 			#: Authorization to put into header when sending requests
	logger = None 				#: logger to send loggin information to.  Logger comes from pytest test definitions

	def __init__(self,apiUrl,logger):

		self.apiUrl = apiUrl
		self.logger = logger

	def makeGetRequest(self):
		"""
		Sends a GET HTTP request.  Make sure you have set the classe's apiParams,apiUrl and apiMethod first

		Args :null

		Returns : (file-like object) the HTTP response 

		Raises :null
		"""

		try:
			encoded_param = urllib.urlencode(self.apiParams)
			url = self.apiUrl+self.apiMethod
			request = urllib2.Request(url+"?"+encoded_param)
			self.logger.info(request.get_full_url())
			return urllib2.urlopen(request)
		except urllib2.URLError,e:
			return e

	def makePostRequest(self):
		"""
		Sends a POST HTTP request.  Make sure you have set the classe's apiParams,apiUrl, apiHeader and apiMethod first

		Args :null

		Returns : (file-like object) the HTTP response 

		Raises :null
		"""

		try:
			url = self.apiUrl+self.apiMethod
			request = urllib2.Request(url)
			encoded_param = urllib.urlencode(self.apiParams)
			request.add_data(encoded_param)
			request.add_header("Authorization",self.apiHeader)

			return urllib2.urlopen(request)


		except urllib2.URLError,e:
			return e
		